import 'package:flutter/cupertino.dart';
import 'package:flutter_mylibrary/config/const.dart';
import 'package:flutter_mylibrary/utils/utils.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import '../../flutter_mylibrary.dart';
import '../base_view_state.dart';
import 'base_view_state_getx_controller.dart';


///该控制类用于model返回
abstract class GetxRequestModelController<T> extends BaseViewStateGetxController{

  T data;


  @override
  void onReady() async{
    _getData();
  }


  ///获取主数据
  void _getData() async{

    request((data) {
      if (isNotEmpty(data)) {
        this.data = getRequestInfo()?.handleRes(data);
        onCompleted(data);
        setIdle();
        refreshController.finishRefresh();
      }else{
        errorType = ViewStateErrorType.noDataError;
        setError(
          errorType: errorType,
        );
      }
    });
  }

  onCompleted(T data) {}

  ///获取一个公共的刷新控件
  Widget getEasyRefreshWidget({Widget emptyWidget, ViewStateModelWidgetBuilder<T> builder, Widget busyWidget, bool showErrorWidget = true, bool showEmptyWidget = true, bool showBusyWidget = true, OnLoadCallback onLoad}){
    Widget emptyErrorWidget = buildRefreshNoDataWidget(viewStateModel: this, busyWidget: busyWidget, emptyDataWidget: emptyWidget, showErrorWidget: showErrorWidget, showEmptyWidget: showEmptyWidget, showBusyWidget: showBusyWidget);
    return EasyRefresh(
      emptyWidget: emptyErrorWidget,
      child: isEmpty(emptyErrorWidget)? builder(data) : Container(),
      onRefresh: isBusy? null : () async{
        _getData();
      },
      onLoad: onLoad,
      controller: refreshController,
    );
  }

}